# cocoa_tools.rb
# RCRunner
#
# Created by Juri Pakaste on 26.11.10.
# Copyright 2010 Juri Pakaste. All rights reserved.

module CocoaTools
  def __each_runloop(args)
    arr, block = args
    if arr.length > 0
      block.call(arr.shift)
      self.performSelector('__each_runloop:', withObject:[arr, block], afterDelay:0)
    end
  end

  def each_runloop(arr, &block)
    self.__each_runloop([Array.new(arr), block])
  end


  def __each_tail_runloop(args)
    arr, block = args
    if arr.length > 0
      first = arr.shift
      block.call(first, arr)
      self.performSelector('__each_tail_runloop:', withObject:[arr, block], afterDelay:0)
    end
  end
    
  def each_tail_runloop(arr, &block)
    self.__each_tail_runloop([Array.new(arr), block])
  end
end
