# tests_provider_facade.rb
# RCRunner
#
# Created by Juri Pakaste on 21.11.10.
# Copyright 2010 Juri Pakaste. All rights reserved.

module RCRunner
  class TestsProviderFacade
    attr_writer :tests_providers

    def tests
      @tests_providers.inject([]) { |memo, tp| memo += tp.tests }
    end

    def run(test)
      return TestResult.new(:fail,
                            "TestsProviderFacade does not support running tests",
                            [],
                            "")
    end
  end


  class Test
    attr_reader :name, :suite

    def initialize(name, suite, provider)
      @name = name
      @suite = suite
      @provider = provider
    end

    def run
      @provider.run(self)
    end
  end


  class TestResult
    # :success, :failure, :error, :skip
    attr_reader :outcome
    attr_reader :reason, :backtrace
    attr_accessor :log

    def initialize(outcome, reason, backtrace, log)
      @outcome = outcome
      @reason = reason
      @backtrace = backtrace
      @log = log
    end
  end
end
